var version     = '1.10.2004040401',
	displayName = 'Tabbrowser Extensions',
	appName     = 'tabextensions',
	author      = 'SHIMODA Hiroshi',
	hasLangPack = true,
	hasJLP      = false,
	hasSkin     = true,
	newTypeOnly = false,
	bindingsName = 'tabextensionsBindings',
	widgetsName  = 'tabextensionsWidgets',
	options     = [
					'sessionManager'
				];


var err         = initInstall(
		displayName,
		appName,
		version
		),
	UChrome     = getFolder('Chrome'),
	messages    = loadResources('locale.inf'),
	optionsMsg  = (options.length ? loadResources('options.inf') : null ),
	installedOptions = [],
	files       = [],
	jarName     = appName+'.jar',
	contentFlag = CONTENT | DELAYED_CHROME,
	localeFlag  = LOCALE | DELAYED_CHROME,
	skinFlag    = SKIN | DELAYED_CHROME,
	i;


var existsInGlobal  = File.exists(getFolder(UChrome, jarName));
var existsInProfile = File.exists(getFolder(getFolder('Current User', 'chrome'), jarName));
var isNewType       = File.exists(getFolder(UChrome, 'browser.jar'));

if (newTypeOnly && !isNewType) {
	alert(messages.newTypeOnly);
	cancelInstall(err);
}
else if (existsInGlobal && existsInProfile) {
	cancelInstall(err);
}
else {

	if (existsInProfile ||
		(!existsInGlobal && confirm(messages.installToProfile))) {
		UChrome = getFolder('Current User', 'chrome');
		contentFlag = CONTENT | PROFILE_CHROME;
		localeFlag  = LOCALE | PROFILE_CHROME;
		skinFlag    = SKIN | PROFILE_CHROME;
	}


	logComment('initInstall: ' + err);
	setPackageFolder(UChrome);

//	if (File.exists(getFolder(UChrome, jarName))) {
//		alert(messages.exists);
//		cancelInstall(err);
//	}
//	else {
		addFile(author, jarName, UChrome, '');
		var folder = getFolder(UChrome, jarName);
		files.push(folder);

		registerChrome(contentFlag, folder, 'content/'+appName+'/');

		if (widgetsName || bindingsName) {
			if (
				isNewType &&
				(
					Install.buildID < 2003111900 &&
					!File.exists(getFolder('Program', 'firefox.exe')) &&
					!File.exists(getFolder('Program', 'firefox-bin.exe')) &&
					!File.exists(getFolder('Program', 'firefox')) &&
					!File.exists(getFolder('Program', 'firefox-bin'))
				)
				) {
				if (widgetsName)
					registerChrome(contentFlag, folder, 'content/'+widgetsName+'/');
			}
			else if (bindingsName)
					registerChrome(contentFlag, folder, 'content/'+bindingsName+'/');
		}


		if (options.length) {
			for (i = 0; i < options.length; i++)
			{
				if (confirm(optionsMsg[options[i]])) {
					registerChrome(contentFlag, folder, 'content/'+options[i]+'/');
					installedOptions.push(options[i]);
				}
			}
		}


		// Language packs
		if (hasLangPack) {
			registerChrome(localeFlag, folder, 'locale/en-US/'+appName+'/');
			registerChrome(localeFlag, folder, 'locale/en-US/'+appName+'/');
			for (i = 0; i < installedOptions.length; i++)
				{
				registerChrome(localeFlag, folder, 'locale/en-US/'+installedOptions[i]+'/');
				registerChrome(localeFlag, folder, 'locale/en-US/'+installedOptions[i]+'/');
				}

			if (hasJLP && confirm(messages.JLP)) {
				registerChrome(localeFlag, folder, 'locale/ja-JP/'+appName+'/');

				for (i = 0; i < installedOptions.length; i++)
					registerChrome(localeFlag, folder, 'locale/ja-JP/'+installedOptions[i]+'/');
			}
		}

		if (hasSkin) {
			registerChrome(skinFlag, folder, 'skin/classic/'+appName+'/');
		}

		err = getLastError();
		if (err == SUCCESS) {
			performInstall();
			alert(
				'Ver.'+version+'\n\n'+
				messages.installed+'\n'+
				files.join('\n')+'\n\n\n'+
				messages.complete+
				(contentFlag & PROFILE_CHROME ? '' : '\n\n'+messages.permissionNotes)
			);
		}
		else {
			cancelInstall(err);
		}
//	}
}
